#ifndef __LHMULTIREFPTR_H__
#define __LHMULTIREFPTR_H__


// Written by Ami


#include "TypedLocalHeap.h" 
#include "MultiRefPtr.h"


class LocalHeapIntCounter
{
private:
	LocalHeapIntCounter();
	LocalHeapIntCounter(LocalHeapIntCounter& SourceLocalHeapIntCounter);
	LocalHeapIntCounter& operator=(LocalHeapIntCounter& SourceLocalHeapIntCounter);

protected:
	int m_nInt;
	static CWizDefaultTypedLocalHeap CommonHeap;
	
public:
	LocalHeapIntCounter(int InInt) : m_nInt(InInt){};
	
	int operator++(){return(++m_nInt);}
	int operator--(){return(--m_nInt);}

	void* operator new(size_t LocalHeapIntCounterSize){return(CommonHeap.Alloc(sizeof(LocalHeapIntCounter)));}
	void operator delete(void *pTargetMemory){CommonHeap.Free(pTargetMemory);}
};


////////////////////////////////////////////////////////////////////


template <class DATA>
class LHMultiRefPtr : public BaseMultiRefPtr<DATA,LocalHeapIntCounter>
{
public:
	LHMultiRefPtr(const LHMultiRefPtr<DATA>& SourceLHMultiRefPtr) :	BaseMultiRefPtr<DATA,LocalHeapIntCounter>(SourceLHMultiRefPtr){}
	LHMultiRefPtr(const DATA* const pSourceData=NULL) :	BaseMultiRefPtr<DATA,LocalHeapIntCounter>(pSourceData){}

	LHMultiRefPtr<DATA>& operator=(const LHMultiRefPtr<DATA> &SourceLHMultiRefPtr){return((LHMultiRefPtr<DATA>&)(BaseMultiRefPtr<DATA,LocalHeapIntCounter>::operator=(SourceLHMultiRefPtr)));}
	LHMultiRefPtr<DATA>& operator=(const DATA* const pSourceData){return((LHMultiRefPtr<DATA>&)(BaseMultiRefPtr<DATA,LocalHeapIntCounter>::operator=(pSourceData)));}

	BOOL operator==(const LHMultiRefPtr<DATA>& SourceLHMultiRefPtr) const{return(BaseMultiRefPtr<DATA,LocalHeapIntCounter>::operator==(SourceLHMultiRefPtr));}
	BOOL operator!=(const LHMultiRefPtr<DATA>& SourceLHMultiRefPtr) const{return(!(*this==SourceLHMultiRefPtr));}
};


#endif // __LHMULTIREFPTR_H__

